# -*- coding: utf-8 -*-

# Copyright (c) 2008, Rectorate of the University of Freiburg
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the distribution.
# * Neither the name of the Freiburg Materials Research Center,
#   University of Freiburg nor the names of its contributors may be used to
#   endorse or promote products derived from this software without specific
#   prior written permission.
#
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
# OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

u"""
"""

__id__ = "$Id: Emd5Src.py 630 2009-04-03 08:19:52Z zklaus $"
__author__ = "$Author: zklaus $"
__version__ = "$Revision: 630 $"
# $Source$

import numpy
from pyphant.core import (Worker, Connectors,
                          Param, DataContainer, KnowledgeManager)

import scipy.interpolate
from pyphant.quantities import PhysicalQuantities
import logging, copy, math

def getDirectory():
    km = KnowledgeManager.KnowledgeManager.getInstance()
    directory = []
    for id in km._refs.iterkeys():
        dc = km.getDataContainer(id)
        directory.append((dc.id, dc.longname, dc.shortname))
    return directory

class Emd5Src(Worker.Worker):
    API = 2
    VERSION = 1
    REVISION = "$Revision: 630 $"[11:-1]
    name = "Emd5Src"

    _params = [("dc", u"Data Container", [u"None"], None)]

    def refreshParams(self, subscriber=None):
        self.paramDc.possibleValues = getDirectory()

    @Worker.plug(Connectors.TYPE_IMAGE)
    def load(self, subscriber=0):
        v = self.paramDc.value
        if isinstance(v, tuple):
            v = v[0]
        km = KnowledgeManager.KnowledgeManager.getInstance()
        return km.getDataContainer(v)
